CREATE TABLE router (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	name VARCHAR(256)
);


CREATE TABLE ip6 (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	router_id INTEGER,
	ip_hi INTEGER(8),
	ip_lo INTEGER(8),
	date  DATE,
	FOREIGN KEY (router_id) REFERENCES router(id),
	UNIQUE (ip_hi, ip_lo, date)
);

CREATE TABLE link (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	router1_id INTEGER,
	router2_id INTEGER,
	date DATE,
	FOREIGN KEY (router1_id) REFERENCES router(id),
	FOREIGN KEY (router2_id) REFERENCES router(id),
	UNIQUE (router1_id, router2_id, date)
);

CREATE TABLE link_properties (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	link_id INTEGER,
	link_property_id INTEGER,
	value VARCHAR(65535),
	date DATE,
	FOREIGN KEY (link_id) REFERENCES link(id),
	FOREIGN KEY (link_property_id) REFERENCES link_property_names(id)
);

CREATE TABLE router_properties (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	router_id INTEGER,
	router_property_id INTEGER,
	date DATE,
	value VARCHAR(65535),
	FOREIGN KEY (router_id) REFERENCES router(id),
	FOREIGN KEY (router_property_id) REFERENCES router_property_names(id)
);

CREATE TABLE router_property_name (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	identifier VARCHAR(256),
	name VARCHAR(4096),
	UNIQUE (identifier)
);

CREATE TABLE link_property_name (
	id INTEGER PRIMARY KEY AUTOINCREMENT,
	identifier VARCHAR(256),
	name VARCHAR(4096),
	UNIQUE (identifier)
);

	
