#! /usr/bin/env python

import sys,os
import getopt,socket
import pydot

def fixid(x):
    return x.translate("________________________________________________0123456789_______ABCDEFGHIJKLMNOPQRSTUVWXYZ______abcdefghijklmnopqrstuvwxyz_____________________________________________________________________________________________________________________________________")


def usage():
    print >>sys.stderr, "Usage: dot2rtg -i <input_file.dot> [-o {filename|{tcp|udp}/ip:port}]"

if __name__ == "__main__":
    OUT = sys.stdout
    DOTFILE = None
    try:
        opts = getopt.getopt(sys.argv[1:], "i:o:")
        for opt, optarg in opts[0]:
            if opt == "-h":
                usage()
            elif opt == "-i":
                DOTFILE = optarg
            elif opt == '-o':
                if optarg.startswith("tcp/") or optarg.startswith("udp/"):
                    OUT = socket.socket(socket.AF_INET, [socket.SOCK_STREAM, socket.SOCK_DGRAM][optarg[0]=='u'])
                    ip,port = optarg[4:].split(":")
                    OUT.connect((ip,int(port)))
                else:
                    OUT = open(optarg,"w")
        if DOTFILE is None:
            raise getopt.GetoptError("No input file was given")
    except getopt.GetoptError,e:
        print >>sys.stderr, "ERROR:",e
        sys.exit(-1)

    g = pydot.graph_from_dot_file(DOTFILE)
    for e in g.get_edge_list():
        os.write(OUT.fileno(), "%s %s\n" % (fixid(e.get_source()), fixid(e.get_destination())))
